// utility functions for file IO

#ifndef FILE_IO_HPP
#define FILE_IO_HPP

#include <iostream>
#include <fstream>
#include "MLConfig.hpp"
#include "GzStream.hpp"

inline std::istream* openInputStream(const std::string& filename) {
  if (filename.compare(filename.size() - 3, 3, ".gz") == 0) {
    return new IGzFStream(filename);
  } else {
    return new std::ifstream(filename.c_str());
  }
}

inline std::ostream* openOutputStream(const std::string& filename) {
  if (filename.compare(filename.size() - 3, 3, ".gz") == 0) {
    return new OGzFStream(filename);
  } else {
    return new std::ofstream(filename.c_str());
  }
}

#endif // FILE_IO_HPP
